//xsetaseta@gmail.com
//Generador 1kHz a 68MHz
//Frecuencimetro de 0 a 8 MHz
//10/10/2020
//http: / / seta43.duckdns.org
//http: / / seta43.blogspot.com /



//LTC6904 con arduino 1.8.5
/*
  I2C SDA (data line) = analog pin 4  ->CHIP SDI-pin2
  I2C SDC (clock line) = analog pin 5 ->CHIP SCK-pin3
  Resistencias de 1K a Vcc. 
  En su defecto la librería WIRE coloca los pins en PULLUP
  con una resistencia de alrededor de 45K. 
*/
#include <Wire.h>
#define LTC6904_ADDRESS 22  // CHIP pin ADR(4)<-VCC


#include "LedControl.h"
/*
 Now we need a LedControl to work with.
 ***** These pin numbers will probably not work with your hardware *****
 pin 12 is connected to the DataIn 
 pin 11 is connected to the CLK 
 pin 10 is connected to LOAD 
 We have only a single MAX72XX.
 */
LedControl lc=LedControl(12,11,10,1);


#include <FreqCounter.h>
//http://interface.khm.de/index.php/labor/experimente/theremin-as-a-capacitive-sensing-device/
//Entrada frecuencia pin D5 del arduino. Hasta 8 MHz


byte display[8];
char segmento=0;
char cadena[20];

int frecu1=0;
int frecu0=0;
long frecux=0;
float frecuxf;

char parpadeo=4;

int modo=0; //0=frecuencimetro    1=Generador


void setFreq(float freq, boolean compOutputOn=true) 
{
  unsigned int oct = (int) (3.322*log10(freq * 1000.0 / 1039.0));
//Los valores originales son: 2048  y  2078
//pero como los chip no están bien tarados debemos encontrar el valor corecto.

  unsigned int dac = (int) (2038.0 - 2059.9* pow(2, 10 + oct) / (freq * 1000.0) + 0.5);

  Serial.print(oct); Serial.print("<-oct X dac->");Serial.println(dac);
     
  unsigned int cnf = compOutputOn ? 0 : 2; 
  unsigned int reg = oct << 12 | dac << 2 | cnf;

  Serial.println(reg);
   
  byte high = (reg >> 8) & 0xff;
  byte low = reg & 0xff;
   
  Wire.beginTransmission(LTC6904_ADDRESS);
  Wire.write(high);
  Wire.write(low);
  Wire.endTransmission();  
}


void printDisplayN(long z,char parpadeo=-1)
{
  sprintf(cadena,"%08li",z);
    lc.setChar(0,7,cadena[0],false);
    lc.setChar(0,6,cadena[1],false);
    lc.setChar(0,5,cadena[2],false);
    lc.setChar(0,4,cadena[3],false);
    lc.setChar(0,3,cadena[4],false);
    lc.setChar(0,2,cadena[5],false);
    lc.setChar(0,1,cadena[6],false);
    lc.setChar(0,0,cadena[7],false);
  
  if(parpadeo>=0)
  {
    switch(segmento)
      {
        case 7:
          lc.setChar(0,7,cadena[0],true);
        break;
        case 6:
          lc.setChar(0,6,cadena[1],true);
        break;
        case 5:
          lc.setChar(0,5,cadena[2],true);
        break;
        case 4:
          lc.setChar(0,4,cadena[3],true);
        break;

        case 3:
          lc.setChar(0,3,cadena[4],true);
        break;
        case 2:
          lc.setChar(0,2,cadena[5],true);
        break;
        case 1:
          lc.setChar(0,1,cadena[6],true);
        break;
        case 0:
          lc.setChar(0,0,cadena[7],true);
        break;
      }
  } 
}


#define ENTRADA1 2
#define ENTRADA2 3
#define ENTRADA3 4

  unsigned long frq;
  int cnt; 
  char VARI[30];


void setup() 
{
  Serial.begin(9600);        // connect to the serial port
  Serial.println(" DUAL ");
  Serial.println("================");

  pinMode(ENTRADA1,INPUT_PULLUP);
  digitalWrite(ENTRADA1,HIGH);
  pinMode(ENTRADA2,INPUT_PULLUP);
  digitalWrite(ENTRADA2,HIGH);
  pinMode(ENTRADA3,INPUT_PULLUP);
  digitalWrite(ENTRADA3,HIGH);

  pinMode(13,OUTPUT);   //Indicador de Generedador/Frecuencimetro

  Wire.begin(); // We're I2C-Bus Master

  lc.shutdown(0,false);
  /* Set the brightness to a medium values */
  lc.setIntensity(0,1);
  /* and clear the display */
  lc.clearDisplay(0);

  printDisplayN(1);
  delay(1000);
  printDisplayN(0);
  delay(1000);

}

void loop() 
{
  if(digitalRead(ENTRADA3) == LOW)
  {
    lc.clearDisplay(0); 
    parpadeo=4;   
    if(modo==0)
      {
        modo=1;
        digitalWrite(13,HIGH);
      }
      else
      {
        modo=0;
        digitalWrite(13,LOW);
      }
    delay(700);    
  }

  
  if(modo==0)
  {
    //FRECUENCIMETRO____________________________________
       // wait if any serial is going on
      FreqCounter::f_comp=10;   // Cal Value / Calibrate with professional Freq Counter
      FreqCounter::start(100);  // 100 ms Gate Time
    
      while (FreqCounter::f_ready == 0) 
    
      frq=FreqCounter::f_freq;
      frq*=10;
      Serial.print(cnt++);  Serial.print("  Frecuencia= ");  Serial.println(frq);
      sprintf(VARI, "%8lu", frq);
      printDisplayN(frq);
      delay(200);
  }
  else
  {
    //GENERADOR FRECUENCIA___________________________________
        if(digitalRead(ENTRADA2) == LOW)
        {
          parpadeo=10;
          segmento++;
          if (segmento>7)segmento=0;
        }
      
        if(digitalRead(ENTRADA1) == LOW)
        {    
            switch(segmento)
            {
             case 7:
                display[0]++; if(display[0]>9) display[0]=0;
             break; 
             case 6:
                display[1]++; if(display[1]>9) display[1]=0;
             break; 
             case 5:
                display[2]++; if(display[2]>9) display[2]=0;
             break; 
             case 4:
                display[3]++; if(display[3]>9) display[3]=0;
             break; 
             case 3:
                display[4]++; if(display[4]>9) display[4]=0;
             break; 
             case 2:
                display[5]++; if(display[5]>9) display[5]=0;
             break; 
             case 1:
                display[6]++; if(display[6]>9) display[6]=0;
             break; 
             case 0:
                display[7]++; if(display[7]>9) display[7]=0;
             break; 
            }
      
            frecu1=display[0]*1000+display[1]*100+display[2]*10+display[3];  
            frecu0=display[4]*1000+display[5]*100+display[6]*10+display[7];
             
            frecux=(long)frecu1*10000 +frecu0;
            printDisplayN(frecux);   
            parpadeo=10;
        }
  
        if(parpadeo<2)
          {
            if(parpadeo==1)
              {
      
                if(frecux<1039)
                  {
                    frecux=1039;
                    display[4]=1;  display[5]=0; display[6]=3;  display[7]=9;
                    display[0]=0;  display[1]=0; display[2]=0;  display[3]=0;
                    printDisplayN(frecux);
                  }
      
                if(frecux>68000000)
                  {
                    frecux=68000000;
                    display[4]=0;  display[5]=0; display[6]=0;  display[7]=0;
                    display[0]=6;  display[1]=8; display[2]=0;  display[3]=0;
                    printDisplayN(frecux);
                  }
      
                parpadeo=0;
                frecuxf=frecux;
                frecuxf/=1000;
                setFreq(frecuxf);
         
                Serial.print("FRECUENCIA="); Serial.println(frecux);
              }
          }
        else
          {
            parpadeo--;
            delay(100);
            printDisplayN(frecux,segmento);
            delay(100);      
            printDisplayN(frecux);
          }    

  }
  
}
